#extractPreviousMatches.awk
#
#This script parses the previously generated motherboard map file and extracts
# the names of the config files that were previously matched for the motherboard
# and each of the slots.

#Set the field separator to "="
BEGIN {
    FS = "="
    numFound = 0
}             

#Set our output variables
END {
     printf( "prevMoboCfgFile=\"%s\"\n", prevMoboCfgFile ) 
     for (i=0; i<numFound; i++) 
     {
         printf( "prevSlotIdx[%s]=\"%s\"\n", i, prevSlotIdx[i] ) 
         printf( "prevSlotCfgFile[%s]=\"%s\"\n", i, prevSlotCfgFile[i] ) 
     }
}                    

#____________________________________________________________________
# This script sets the following shell variables
#   prevMoboCfgFile - file name of the previously matched motherboard.
#   prevSlotCfgFile - array of previously matched config files for each of 
#                     the populated slots
#   prevSlotIdx - array of slot numbers corresponding to the matched files above
#____________________________________________________________________
    {
        if ( match ($1, /^[ \t]*CFG_MOBO/) ) 
        {
            prevMoboCfgFile = $2
        }
        if ( match ($1, /^[ \t]*CFG_SLOT[0-9]+/) ) 
        {
            len = RLENGTH
            match ($1, /^[ \t]*CFG_SLOT/)
            slotnum = substr ($1, RLENGTH+1, len-RLENGTH)
            prevSlotIdx[numFound] = slotnum
            prevSlotCfgFile[numFound] = $2
            ++numFound
        }
    } 


