#!/bin/bash


# only run this on 8210
if sysctl -n pts14k.board > /dev/null 2> /dev/null
then
    exit 0
fi

if ! num_bypass=$(sysctl -n hw.bypass_devices 2>/dev/null); then
	num_bypass=0
fi

#source rc.conf.local if it exists
if [ -f /etc/defaults/rc.conf ] 
then
	. /etc/defaults/rc.conf
	source_rc_confs
else
	bypass_on_shutdown="yes"
	bypass_default_timeout=10000
fi


function start
{
	for ((dev=0; dev < num_bypass; dev++))
	do
		sysctl hw.bypass${dev}.wd_timeout=${bypass_default_timeout} > /dev/null 2>/dev/null
	done
        if [ -f /etc/bridge.conf ] 
	then
		# if bridge.config is available, enable bridging
		bridgeConf=$(cat /etc/bridge.conf)
		sysctl net.link.ether.bridge_cfg=${bridgeConf} > /dev/null 2>/dev/null
		sysctl net.link.ether.bridge=1 > /dev/null 2>/dev/null
	else
		# disable bypass and enable kernel watchdog
	        loadWatchdog
	fi
        rm /var/run/bypass.mode > /dev/null 2>/dev/null
}

function stop
{
	if [ "$bypass_on_shutdown" == "yes" ]; then
		bypass
	fi
}

function loadWatchdog
{
	for ((dev=0; dev < num_bypass; dev++))
	do
		sysctl hw.bypass${dev}.wd_timeout=${bypass_default_timeout} > /dev/null 2>/dev/null
		sysctl hw.bypass${dev}.wd_mode=2 > /dev/null 2>/dev/null
                dev1=$(expr $dev + 1)
		/usr/local/sandvine/bin/set interface $dev1 mode software > /dev/null 2>/dev/null 
                if [ $? -ne 0 ]
                then                  
                  sysctl hw.bypass${dev}.adminStatus=2 > /dev/null 2>/dev/null 
                fi
	done
}

function bypass
{
	cli_failed=0
	for ((dev=0; dev < num_bypass; dev++))
	do
                dev1=$(expr $dev + 1)
                /usr/local/sandvine/bin/set interface $dev1 mode bypass > /dev/null 2>/dev/null 
                if [ $? -ne 0 ]
                then 
                  # likely scdpd isn't running, set via old method               		  
                  sysctl hw.bypass${dev}.adminStatus=0 > /dev/null 2>/dev/null 
                  cli_failed=1
                fi
	done
        if [ $cli_failed -ne 0 ]
        then
	        echo "manual bypass" > /var/run/bypass.mode
	        sysctl svftx.manual_bypass=1 > /dev/null 2>/dev/null
        fi
}

function active
{
	 cli_failed=0
	 for ((dev=0; dev < num_bypass; dev++))
	 do
                dev1=$(expr $dev + 1)
		/usr/local/sandvine/bin/set interface $dev1 mode active > /dev/null 2>/dev/null 
                if [ $? -ne 0 ]
                then                    
                  # likely scdpd isn't running, set via old method              
                  sysctl hw.bypass${dev}.adminStatus=1 > /dev/null 2>/dev/null 
                  cli_failed=1
                fi
	 done
         if [ $cli_failed -ne 0 ]
         then
	       rm /var/run/bypass.mode > /dev/null 2>/dev/null
	       sysctl svftx.manual_bypass=0 > /dev/null 2>/dev/null
         fi
}

function status
{
	echo "$num_bypass bypass cards installed"
	for ((dev=0; dev < num_bypass; dev++))
	do
		operStatus=$(sysctl -n hw.bypass${dev}.operStatus)
		if [ $operStatus -ne 0 ]
		then
			echo "Bypass device $dev is active"
		else
			echo "Bypass device $dev is in bypass state"
		fi
	done
}

case "$1" in
restart)
	start
	;;
start|faststart)
	start
	;;
stop)
	stop
        ;;
bypass)
	bypass
        ;;
active)
	active
        ;;
status)
	status
	;;	
*)
        echo "Usage: `basename $0` {start|stop|active|bypass|restart|status}" >&2 
	;;
esac

exit 0
